//tema_main.c

#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <pthread.h>
#include <sys/time.h>
#include "mrtu.h"
#include "main.h" 		//подключаем наш заголовочный файл 
#include "rsocket.h"		//подключаем заголовочный файл для работы с сокетами

int	ipport;	//наш порт прослушивания

int	num_work;	//сётчик для работы
/*
************************
массив рабочих регистров
************************
*/
I16	regs[_cnt_regs];

int main(int argc, char **argv)
{
	int scnt = 1; //счётчик для анализа входных параметров
	int res = 1;
	char	serialname[255] = {0};
	//без параметров
	if(argc < 2)
	{
		printf("\nParametrs not defined!\r\n");
		printf("\"--help\" for information\n");
		return 1;
	}
	//
	while(scnt < argc)
	{
		//подсказка
		if(strcmp(argv[scnt], "--help") == 0)
		{
			printf(__help);
			return 0;
		}
		//порт TCP
                else if(strcmp(argv[scnt], "-p") == 0)
                {
                        scnt++;
                        if(!(scnt < argc))
                                return 2;
                        ipport = atoi(argv[scnt]);
                        if(ipport == 0)
				return 3;
		}
		//последовательный порт
		else if(strcmp(argv[scnt], "-sp") == 0)
                {
                        scnt++;
                        if(!(scnt < argc))
                                return 2;
                        strcpy(&serialname[0], argv[scnt]);
		}
		else
			return 4;
		scnt++;
	}
	//открытие прослушивающего сокета - запуск сервера
	res = SocketStart();
	printf("---- opening tcp/ip  %u ----\r\n", ipport);
	if(res != 0)
	{
		printf("ERROR starting server\n");
		return 5;
	}
	//соединяемся с Arduino
	res = MRTU_Connect(&serialname[0]);
	if(res != 0)
	{
		SocketStop();
		printf("ERROR connecting to Arduino\n");
		return 5;
	}
	//обнуляем рабочий счётчик
	num_work = 0;
	//наш цикл Main
	while(1)
	{
		MainWork();	//Рабочая функция
		usleep(50000);	//ожтдание (uS)
	}
	//
	return 0;
}

//рабочий модуль
void	MainWork(void)
{
	I16	val;
	I16	motors[4];
	I16	servos[18];
	int	count;
	int	addr;
	//
	pthread_mutex_lock(&ServerMutex);
	//копирование заданий регистров
	addr 	= 0;
	count	= 0;
	while(count < _cnt_regs)
	{
		regs[count] = (*(I16*)(&wbuffrom[addr]));
		addr += 2;	
		count++;
	}
	//копировние значений регистров
	addr 	= 0;
	count	= 0;
	while(count < _cnt_regs)
	{
		(*(I16*)(&wbufto[addr])) = regs[count];
		addr += 2;	
		count++;
	}
	//
	/*switch(num_work)
	{
		case 0:	//привод 1
			val = regs[_num_vol_m1];
			pthread_mutex_unlock(&ServerMutex);
			MRTU_CMD_6(1, _num_vol_m1, val);
			num_work++;
			break;
		case 1:	//привод 2
			val = regs[_num_vol_m2];
			pthread_mutex_unlock(&ServerMutex);
			MRTU_CMD_6(1, _num_vol_m2, val);
			num_work++;
			break;
		case 2:	//привод 3
			val = regs[_num_vol_m3];
			pthread_mutex_unlock(&ServerMutex);
			MRTU_CMD_6(1, _num_vol_m3, val);
			num_work++;
			break;
		case 3:	//привод 4
			val = regs[_num_vol_m4];
			pthread_mutex_unlock(&ServerMutex);
			MRTU_CMD_6(1, _num_vol_m4, val);
			num_work++;
			break;
		case 4:	//горизонтальная позиция камеры
			val = regs[_num_pos_s1];
			pthread_mutex_unlock(&ServerMutex);
			MRTU_CMD_6(1, _num_pos_s1, val);
			num_work++;
			break;
		case 5:	//вертикальная позиция камеры
			val = regs[_num_pos_s2];
			pthread_mutex_unlock(&ServerMutex);
			MRTU_CMD_6(1, _num_pos_s2, val);
			num_work++;
			break;
		default:
			num_work = 0;
			pthread_mutex_unlock(&ServerMutex);
			break;
	}*/
	switch(num_work)
	{
		case 0:
			memcpy(&motors[0], &regs[_num_vol_m1], 8);
			pthread_mutex_unlock(&ServerMutex);
			MRTU_CMD_16(1, _num_vol_m1, &motors[0], 4);
			num_work++;
			break;
		case 1:	//горизонтальная позиция камеры
			val = regs[_num_pos_s1];
			pthread_mutex_unlock(&ServerMutex);
			MRTU_CMD_6(1, _num_pos_s1, val);
			num_work++;
			break;
		case 2:	//вертикальная позиция камеры
			val = regs[_num_pos_s2];
			pthread_mutex_unlock(&ServerMutex);
			MRTU_CMD_6(1, _num_pos_s2, val);
			num_work = 0;
			break;
		default:
			num_work = 0;
			pthread_mutex_unlock(&ServerMutex);
			break;
	}
}
