//tema_main.h


#ifndef _tema_main_h_ //если компилятор этим не пользовался
#define _tema_main_h_ //говорим что уже пользовался и определяем следующее

#include "types.h"

//наша подсказка для параметра --help
#define __help	"\
\n\n======== Arduino Raspberry Bot control devices server =======\n\
arbot <parameters> :\n\
\n\
    --help               - current info\n\
\n\
    -p <port>            - tcp port for listen\n\
                           <port> number tcp port\n\
    -sp <port> <speed>   - name and speed of serial port\n\ 
                           <port> serial port(use recommended /dev/ttyUSB0)\n\
                           <speed> speed for serial port (use recommended baudrate 9600)\n\
\r\n"

#define _size_wbuf	1020

/*
************************
массив рабочих регистров
************************
*/
#define _cnt_regs	256	//количество регистров
extern I16	regs[_cnt_regs];
//рабочие определения
#define _num_vol_m1	0x30	//номер регистра привода 1
#define _num_vol_m2	0x31	//номер регистра привода 2
#define _num_vol_m3	0x32	//номер регистра привода 3
#define _num_vol_m4	0x33	//номер регистра привода 4
#define _num_pos_s1	0x40	//номер регистра позиции севомашины 1
#define _num_pos_s2	0x41	//номер регистра позиции севомашины 2
#define _num_pos_s3	0x42	//номер регистра позиции севомашины 3
#define _num_pos_s4	0x43	//номер регистра позиции севомашины 4
#define _num_pos_s5	0x44	//номер регистра позиции севомашины 5
#define _num_pos_s6	0x45	//номер регистра позиции севомашины 6
#define _num_pos_s7	0x46	//номер регистра позиции севомашины 7
#define _num_pos_s8	0x47	//номер регистра позиции севомашины 8
#define _num_pos_s9	0x48	//номер регистра позиции севомашины 9
#define _num_pos_s10	0x49	//номер регистра позиции севомашины 10
#define _num_pos_s11	0x4A	//номер регистра позиции севомашины 11
#define _num_pos_s12	0x4B	//номер регистра позиции севомашины 12
#define _num_pos_s13	0x4C	//номер регистра позиции севомашины 13
#define _num_pos_s14	0x4D	//номер регистра позиции севомашины 14
#define _num_pos_s15	0x4E	//номер регистра позиции севомашины 15
#define _num_pos_s16	0x4F	//номер регистра позиции севомашины 16
#define _num_pos_s17	0x50	//номер регистра позиции севомашины 17
#define _num_pos_s18	0x51	//номер регистра позиции севомашины 18

//объявляем рабочие данные для всех
extern U8	wbuffrom[_size_wbuf];
extern U8	wbufto[_size_wbuf];

extern int	ipport;	//наш порт прослушивания - объявляем для всех

void	MainWork(void);	//объявляем тестовый модуль

extern pthread_mutex_t         ServerMutex;	//объявляем наш мютекс для всех
#endif
