//tema_socket.c

#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <pthread.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/time.h>
#include "types.h"		//наши определения типов - для удобства
#include "rsocket.h"		//подключаем наш заголовочный файл для работы с сокетами
#include "main.h"		//подключаем заголовочный файл нашего MAIN

int	listener;
struct  sockaddr_in     addr;

//рабочие данные
U8	wbuffrom[_size_wbuf];
U8	wbufto[_size_wbuf];

pthread_mutex_t         ServerMutex;
pthread_t     		hListenProcess;
int	 		TServerMutex;
WSERV			WServer;

int	SocketStart(void)
{
       	listener = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
        if(listener < 0)
                return -1;
        addr.sin_family = AF_INET;
        addr.sin_port = htons(ipport);
        addr.sin_addr.s_addr = htonl(INADDR_ANY);
        memset(&addr.sin_zero, 0, 8);
        if(bind(listener, (struct sockaddr *)&addr, sizeof(addr)) < 0)
                return -2;
        if(listen(listener, _max_sock) < 0)
                return -3;
        //создаём мютекс
        //TServerMutex = _ServerTimeMutex;
        if(!(pthread_mutex_init(&ServerMutex,NULL) == 0))
                return -4;
        //запуск потока прослушивания
        WServer.work = 1;	//флаг "работы"
        pthread_create(&hListenProcess,NULL,(void*) ListenProcess,NULL);
	//
        sleep(1);       //wait one secoond
        //
        return 0;
}

int SocketStop(void)
{
	pthread_mutex_lock(&ServerMutex);
	close(listener);
	WServer.work = 1;
	pthread_mutex_unlock(&ServerMutex);
	return 0;
}

//поток прослушивания
void ListenProcess(void)
{
        int 		err;
        fd_set 		fdss;
        struct timeval 	tvs;
        int 		count;
        int 		csock;
	pthread_attr_t 	tattr;
	//параметры для отделяемых потоков
	pthread_attr_init(&tattr);
	pthread_attr_setdetachstate(&tattr, PTHREAD_CREATE_DETACHED);
        //инициализация данных
        memset(&WServer.midcl[0], 0, _max_sock);
        WServer.cntclient = 0;
	WServer.set_pr_ssleep	= _cl_pr_ssleep;
	WServer.setcntlive	= _time_life;
	//основной цикл прослушивания
        while(WServer.work)
        {
mt1:            tvs.tv_sec = 0;
                tvs.tv_usec = _LSOCKET_TIMEOUT;
                FD_ZERO(&fdss);
                FD_SET(listener,&fdss);
                //
                err = select(listener + 1,&fdss,&fdss,NULL,&tvs);
                if(err <= 0)
                {
                        usleep(_SSLEEP);
                        goto mt1;
                }
                csock = accept(listener,NULL,NULL);
                if((WServer.csock > 0) && (csock == WServer.csock))
                {
                        usleep(_SSLEEP);
                        goto mt1;
                }
		//создание потока клиента
                printf("-- CLIENT sock. %i --\r\n", csock);
                count = 0;
                while(count < _max_sock)
                {
                        if(WServer.midcl[count] == 0)
                        {
                                WServer.csock 			= csock;	//принятый для работы сокет
                                WServer.idclient 		= count;	//номер клиента
				WServer.midcl[count]		= 0xFF;		//место клиента зафиксировано
                                //pthread_create(&WServer.pth[count],NULL,(void*) ClientProcess, &MRTUServer);	//неотделяемый поток
				pthread_create(&WServer.pth[count],&tattr,(void*) ClientProcess, &WServer);	//отделяемый поток
                                WServer.cntclient++;				//счётчик клиентов
				break;
                        }
                        count++;
                }
                //
                //usleep(TServerMutex);
                usleep(_pr_ssleep);
        }
	pthread_exit(0);
}


inline int ReadSocket(int nSocket, BYTE *pBuffer)
{
        //int     res                     = 1;
        int     	iRC                     = 0;
        int     	iReceiveStatus          = 0;
        int     	iStillToReceive         = 2;	//начальный размер получения минимальных данных
        int     	iCount 	= 0;
	int		sz;
        struct timeval 	ReceiveTimeout;
        fd_set 		fds;
	U8		flag			= 0;	//флаг получения размера дляприёма
	//
        while(iStillToReceive > 0)
        {
                //установка величины таймаута
                FD_ZERO(&fds);
                FD_SET(nSocket, &fds);
                ReceiveTimeout.tv_sec  = 0;
                ReceiveTimeout.tv_usec = _rSOCKET_TIMEOUT_;
                iRC = select(nSocket + 1, &fds, NULL, NULL, &ReceiveTimeout);
                //выход по таймауту
                if(!iRC)
			return -1;
		//произошла какая то ошибка
                if(iRC < 0)
                        return -2;
		//ошибка указания размера данных
                if(iStillToReceive <= 0)
                        return -3;
                //прием нескольких байт
		iReceiveStatus = recv(nSocket, (char*)(pBuffer), iStillToReceive, 0);
                if(iReceiveStatus >  0)
                {
			pBuffer += iReceiveStatus;
                        iStillToReceive -= iReceiveStatus;
                        iCount += iReceiveStatus;
			if((iCount >= 2) && (flag == 0))
			{ 
				sz		= (*(U16*)(pBuffer - iCount));
				iStillToReceive = sz - iCount;
				flag = 0xFF;
			}
                }
		else if(iReceiveStatus == 0)
			return -1;
		else
			return -2;
        }
	//дополнительная проверка размера
	if(sz != iCount)
		return -3;
        //
        return iCount;
}


inline int WriteSocket(int nSocket, BYTE *pBuffer, U16 iMessageLength)
{
 	int 		iCount		= 0;
        int 		iSC 		= 0;
        int 		iSendStatus 	= 0;
        struct timeval 	SendTimeout;
        fd_set 		fds;
	//fcntl(nSocket, F_SETFL, O_NONBLOCK);
        while(iMessageLength > 0)
        {
		//установка величины таймаута
        	SendTimeout.tv_sec  = 0;
        	SendTimeout.tv_usec = _wSOCKET_TIMEOUT_;
        	FD_ZERO(&fds);
        	FD_SET(nSocket, &fds);
                iSC = select(nSocket + 1, NULL, &fds, NULL, &SendTimeout);
                if(!iSC)
                        return -1; //таймаут
                if(iSC < 0)
                        return -2; //ошибка
		//отправить несколько байт
		iSendStatus = send(nSocket, (char*)(pBuffer), iMessageLength, 0);
                if(iSendStatus > 0)
                {
                        //обновить буфер и счетчик
                        iMessageLength -= iSendStatus;
                        pBuffer += iSendStatus;
                        iCount += iSendStatus;
                }
		else if(iSendStatus == 0)
			return -1;
		else
			return -2;
        }
	return iCount;
}





//поток работы с входящим соединением
void ClientProcess(WSERV * cs)
{
	int		countlive	= _time_life;
	//int		setcntlive;
	int		csock;
	int		idclient;
	//int		rd;
	pthread_t	pth;
	U8		midcl;
	U8		rxbuf[_size_buf];
	U8		txbuf[_size_buf];
	int		txsz 		= 0;
	U8		work;
	int		res;
	//
	printf("---- CLIENT START ----\n");
	//занимаем мютекс
	pthread_mutex_lock(&ServerMutex);
	//
	//countlive 	= cs->setcntlive;
	//setcntlive	= cs->setcntlive;
	csock		= cs->csock;
	idclient	= cs->idclient;
	midcl		= cs->midcl[idclient];
	pth		= cs->pth[idclient];
	work		= cs->work;
	//
	pthread_mutex_unlock(&ServerMutex);
	//
	while(work)
	{
		//чтение сокета
		txsz = 0;
		memset(&rxbuf[0], 0, _size_buf);
		res = ReadSocket(csock, &rxbuf[0]);
		switch(res)
		{
			case 0:	//Null
				break;
			case -1: 			//таймаут
				break;
			case -2: 			//какая-то ошибка сокета
				goto mexit;
			case -3: 			//ошибка размера пакета
				break;
			default: 			//нормально - данные приняты
				countlive = _time_life;
				break;
		}
		//занимаем мютекс и копируем данные в/из рабочий/рабочего массива
		pthread_mutex_lock(&ServerMutex);
		if(rxbuf[_type_tcp_pkt] & _type_tcp_pkt_mask_rd)		//данные клиенту ?
		{
			memcpy(&txbuf[_data_pkt], &wbufto[0], _size_wbuf);	//копируем в буфер для передачи из рабочих данных
			//заполняем служебные данные
			memcpy(&txbuf[0], &rxbuf[0], 4);			//размер и параметры, что запросил клиент
			txsz = (int)(*(U16*)(&rxbuf[_sizeL_tcp_pkt]));		//установим размер для передачи
		}
		if(rxbuf[_type_tcp_pkt] & _type_tcp_pkt_mask_wr)		//данные от клиента ?
			memcpy(&wbuffrom[0], &rxbuf[_data_pkt], _size_wbuf);	//копируем в рабочие данные от клиента
		pthread_mutex_unlock(&ServerMutex);
		//передача данных
		if(txsz > 0)
		{
			//pthread_mutex_unlock(&ServerMutex);
			res = WriteSocket(csock, &txbuf[0], txsz);
			switch(res)
			{
				case 0:
					break;
				case -1:		//таймаут
					break;
				case -2:		//какая-то ошибка сокета
					goto mexit;
				default:		//нормально - данные переданы
					//countlive = _time_life;
					break;
			}
		}
		//ожидание и новый цикл
		usleep(_cl_pr_ssleep);
		countlive--;
		if(!(countlive > 0)) //никому это соединение не нужно
			break;
	}
mexit:	close(csock);
	pthread_mutex_lock(&ServerMutex);
	cs->pth[idclient]	= 0;
	cs->midcl[idclient]	= 0;
	cs->cntclient--;
	pthread_mutex_unlock(&ServerMutex);
	printf("---- CLIENT STOP ----\n");
	pthread_exit(0); 
}


