//tema_socket.h


#ifndef _tema_socket_h_
#define _tema_socket_h_

#include "types.h"

#define _max_sock		10		//максимальное количество входящих соединений
#define _pr_ssleep              30000		//время сна "процесса" прослушивания
#define _cl_pr_ssleep		20000		//время сна "процесса" работы с соединением
#define _SSLEEP			100000		//время ожидания после "ошибки" по select и accept
#define _LSOCKET_TIMEOUT        10000000
#define _time_life		50		//время жизни сокета при отсутствии запросов (удалять процесс если нет обращения)
#define _rSOCKET_TIMEOUT_       7000000 
#define _wSOCKET_TIMEOUT_	7000000

#define _size_buf		1024		//размер буфера для приёма и передачи по TCP
//описание формата обмена
#define _sizeL_tcp_pkt		0x0000		//размер пакета TCP (L)
#define _sizeH_tcp_pkt		0x0001		//размер пакета TCP (H)
#define _type_tcp_pkt		0x0002		//тип пакета (запроса-ответа)
#define _cmd_tcp_pkt		0x0003		//команда обращения
#define _data_pkt		0x0004		//начало данных
//значения - маски типа пакета
#define _type_tcp_pkt_mask_rd	_bit_0		//данные передаются из модуля обработки клиенту
#define _type_tcp_pkt_mask_wr	_bit_1		//данные принимаются в модуль обработки от клиента


//структура для данных сервера
typedef struct _WSERV
{
	U8			work;			//флаг работы по сокетам
	int			cntclient;		//счётчик клиентов для
	int			idclient;		//номер-идентификатор клиента в массиве
	U8			midcl[_max_sock];	//массив флагов активности клиентов
	pthread_t       	pth[_max_sock];		//массив потоков
	int			csock;			//сокет клиента
	U32			setcntlive;		//установка счётчика жизни сокета без связи (обрыв соединения)
	U32			cntlive;		//счётчик времени жизни сокета
	U32			set_pr_ssleep;		//время бездействия клиента (сна)
}WSERV;

extern WSERV			WServer;	

void    	ListenProcess(void);			//объявляем процесс прослушивания
void		ClientProcess(WSERV * mrtucl);		//объявление процесса связи с клиентом

extern int	SocketStart(void);			//объявляем для всех - в частности для MAIN

#endif

